/*
 * PETScExt.h
 *
 *  Created on: 01.12.2012
 *      Author: Felix Ospald
 */

#ifndef FMG_PETSCEXT_H_
#define FMG_PETSCEXT_H_

#include <petscsys.h>
#include <petscmat.h>

namespace fmg {

/// This class contains some useful extension methods for PETSc.

class PETScExt
{
public:
	/// Zero rows columns of a matrix.
	static PetscErrorCode MatZeroRowsColumnsIS_SeqAIJ(Mat mat, IS isrows, IS iscols);
	static PetscErrorCode MatZeroRowsColumns_SeqAIJ(Mat A, PetscInt M, const PetscInt rows[], PetscInt N, const PetscInt cols[]);

}; // class

} // namespace

#endif /* FMG_PETSCEXT_H_ */
