#!/bin/bash

printf "Please enter the install path for FMG (default ~/fmg): "
read FMG_DIR

if [ -z "$FMG_DIR" ]; then
	FMG_DIR=~/fmg
fi

cmake -DCMAKE_INSTALL_PREFIX:PATH=$FMG_DIR . 2>&1 | tee .cmakelog

if [ ! -z "$(cat .cmakelog | egrep 'Adjust CMAKE|Error')" ]; then

	INSTALLS=$(locate dolfin-config.cmake)

	if [ -z "$INSTALLS" ]; then
		echo "There was an error running cmake. Please do a manual installation."
		exit
	fi

	echo "There was an error running cmake please specify path of your dolfin-config.cmake:"

	k = 0
	echo "$INSTALLS" | while read i
	do
		k=$(($k+1))
		echo "   $k) $(dirname $i)"
	done

	printf "1-$k: "
	read i

	INSTALL=$(echo "$INSTALLS" | awk "NR==$i")
	export dolfin_PATH=$(dirname "$INSTALL")
fi

cmake -DCMAKE_INSTALL_PREFIX:PATH=$FMG_DIR . 2>&1 | tee .cmakelog

if [ ! -z "$(cat .cmakelog | egrep 'Adjust CMAKE|Error')" ]; then
	echo "There was an error running cmake. Please do a manual installation."
	exit
fi

make -j && make install

